#include <gtk/gtk.h>
#include <eventconfig.h>
#include <jmp.h>
#include <jmp-config.h>

/* Dialog for filter options */
static GtkWidget *dialog;

/* Called when OK or Quit button of the options dialog is pressed */
void event_close_dialog (GtkWidget *widget, gpointer data) {
    gtk_widget_hide (dialog);
}

void object_event_changed (GtkWidget *w, gpointer fm) {
    if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (w))) {
	enable_object_events ();
	run_object_dump ();
    } else {
	disable_object_events ();
    }
}

void method_event_changed (GtkWidget *w, gpointer fm) {
    if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (w))) {
	enable_method_events ();
    } else {
	disable_method_events ();
    }
}

void monitor_event_changed (GtkWidget *w, gpointer fm) {
    if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (w))) {
	enable_monitor_events ();
    } else {
	disable_monitor_events ();
    }
}

void event_window (GtkObject *ignored) {
    if (dialog == NULL) {
	GtkWidget *b = gtk_vbox_new (TRUE,0), *b2;
	GtkWidget *w;

	dialog = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW (dialog),
			      _("Java Memory Profiler - Filter Options"));
	gtk_window_set_modal (GTK_WINDOW (dialog),TRUE);
	gtk_container_set_border_width (GTK_CONTAINER (dialog),10);
	
	w = gtk_check_button_new_with_label (_("Enable object tracing"));
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (w), tracing_objects ());
	gtk_box_pack_start (GTK_BOX (b), w, FALSE,FALSE,0);
	gtk_signal_connect (GTK_OBJECT (w), "toggled",
			    GTK_SIGNAL_FUNC (object_event_changed), (gpointer)NULL);
	w = gtk_check_button_new_with_label (_("Enable method tracing"));
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (w), tracing_methods ());
	gtk_box_pack_start (GTK_BOX (b), w, FALSE,FALSE,0);
	gtk_signal_connect (GTK_OBJECT (w), "toggled",
			    GTK_SIGNAL_FUNC (method_event_changed), (gpointer)NULL);
	w = gtk_check_button_new_with_label (_("Enable monitor tracing"));
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (w), tracing_monitors ());
	gtk_box_pack_start (GTK_BOX (b), w, FALSE,FALSE,0);
	gtk_signal_connect (GTK_OBJECT (w), "toggled",
			    GTK_SIGNAL_FUNC (monitor_event_changed), (gpointer)NULL);

	/* Ok and Quit button */
	b2 = gtk_hbutton_box_new ();
	w = gtk_button_new_with_label (_("OK"));
	gtk_signal_connect (GTK_OBJECT (w),"clicked",
			    GTK_SIGNAL_FUNC (event_close_dialog),
			    (gpointer)TRUE);
	gtk_box_pack_start (GTK_BOX (b2), w, FALSE,FALSE,0);
	gtk_widget_show (b2);
	gtk_box_pack_start (GTK_BOX (b), b2, FALSE,FALSE,0);
	gtk_container_add (GTK_CONTAINER (dialog), b);
    }	
    gtk_widget_show_all (dialog);	
}
